diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/traffic-control/bindings/modulegen__gcc_LP64.py ns-3.36/src/traffic-control/bindings/modulegen__gcc_LP64.py
--- ns-3.35/src/traffic-control/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/traffic-control/bindings/modulegen__gcc_LP64.py	2022-04-30 18:23:58.166735000 -0700
@@ -6496,10 +6505,16 @@
     cls.add_method('ExtractNeighborIndex', 
                    'uint32_t', 
                    [param('uint32_t', 'numberOfBits')])
-    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetRemainingBits() [member function]
+    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetEpoch() const [member function]
+    cls.add_method('GetEpoch', 
+                   'uint32_t', 
+                   [], 
+                   is_const=True)
+    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetRemainingBits() const [member function]
     cls.add_method('GetRemainingBits', 
                    'uint32_t', 
-                   [])
+                   [], 
+                   is_const=True)
     ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetSerializedSize() const [member function]
     cls.add_method('GetSerializedSize', 
                    'uint32_t', 
@@ -6510,6 +6525,10 @@
                    'uint32_t', 
                    [param('uint32_t *', 'buffer'), param('uint32_t', 'maxSize')], 
                    is_const=True)
+    ## nix-vector.h (module 'network'): void ns3::NixVector::SetEpoch(uint32_t epoch) [member function]
+    cls.add_method('SetEpoch', 
+                   'void', 
+                   [param('uint32_t', 'epoch')])
     return
 
 def register_Ns3Node_methods(root_module, cls):
@@ -6873,10 +6892,11 @@
                    'uint32_t', 
                    [param('uint8_t *', 'buffer'), param('uint32_t', 'maxSize')], 
                    is_const=True)
-    ## packet.h (module 'network'): void ns3::Packet::SetNixVector(ns3::Ptr<ns3::NixVector> nixVector) [member function]
+    ## packet.h (module 'network'): void ns3::Packet::SetNixVector(ns3::Ptr<ns3::NixVector> nixVector) const [member function]
     cls.add_method('SetNixVector', 
                    'void', 
-                   [param('ns3::Ptr< ns3::NixVector >', 'nixVector')])
+                   [param('ns3::Ptr< ns3::NixVector >', 'nixVector')], 
+                   is_const=True)
     ## packet.h (module 'network'): std::string ns3::Packet::ToString() const [member function]
     cls.add_method('ToString', 
                    'std::string', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/traffic-control/CMakeLists.txt ns-3.36/src/traffic-control/CMakeLists.txt
--- ns-3.35/src/traffic-control/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/traffic-control/CMakeLists.txt	2022-04-30 18:23:58.166735000 -0700
@@ -0,0 +1,54 @@
+build_lib(
+  LIBNAME traffic-control
+  SOURCE_FILES
+    helper/queue-disc-container.cc
+    helper/traffic-control-helper.cc
+    model/cobalt-queue-disc.cc
+    model/codel-queue-disc.cc
+    model/fifo-queue-disc.cc
+    model/fq-cobalt-queue-disc.cc
+    model/fq-codel-queue-disc.cc
+    model/fq-pie-queue-disc.cc
+    model/mq-queue-disc.cc
+    model/packet-filter.cc
+    model/pfifo-fast-queue-disc.cc
+    model/pie-queue-disc.cc
+    model/prio-queue-disc.cc
+    model/queue-disc.cc
+    model/red-queue-disc.cc
+    model/tbf-queue-disc.cc
+    model/traffic-control-layer.cc
+  HEADER_FILES
+    helper/queue-disc-container.h
+    helper/traffic-control-helper.h
+    model/cobalt-queue-disc.h
+    model/codel-queue-disc.h
+    model/fifo-queue-disc.h
+    model/fq-cobalt-queue-disc.h
+    model/fq-codel-queue-disc.h
+    model/fq-pie-queue-disc.h
+    model/mq-queue-disc.h
+    model/packet-filter.h
+    model/pfifo-fast-queue-disc.h
+    model/pie-queue-disc.h
+    model/prio-queue-disc.h
+    model/queue-disc.h
+    model/red-queue-disc.h
+    model/tbf-queue-disc.h
+    model/traffic-control-layer.h
+  LIBRARIES_TO_LINK
+    ${libnetwork}
+    ${libcore}
+    ${libconfig-store}
+  TEST_SOURCES
+    test/adaptive-red-queue-disc-test-suite.cc
+    test/cobalt-queue-disc-test-suite.cc
+    test/codel-queue-disc-test-suite.cc
+    test/fifo-queue-disc-test-suite.cc
+    test/pie-queue-disc-test-suite.cc
+    test/prio-queue-disc-test-suite.cc
+    test/queue-disc-traces-test-suite.cc
+    test/red-queue-disc-test-suite.cc
+    test/tbf-queue-disc-test-suite.cc
+    test/tc-flow-control-test-suite.cc
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/traffic-control/examples/CMakeLists.txt ns-3.36/src/traffic-control/examples/CMakeLists.txt
--- ns-3.35/src/traffic-control/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/traffic-control/examples/CMakeLists.txt	2022-04-30 18:23:58.166735000 -0700
@@ -0,0 +1,88 @@
+build_lib_example(
+  NAME red-tests
+  SOURCE_FILES red-tests.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libinternet}
+    ${libapplications}
+    ${libflow-monitor}
+    ${libtraffic-control}
+)
+
+build_lib_example(
+  NAME red-vs-ared
+  SOURCE_FILES red-vs-ared.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libpoint-to-point-layout}
+    ${libinternet}
+    ${libapplications}
+    ${libtraffic-control}
+)
+
+build_lib_example(
+  NAME adaptive-red-tests
+  SOURCE_FILES adaptive-red-tests.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libinternet}
+    ${libapplications}
+    ${libflow-monitor}
+    ${libtraffic-control}
+)
+
+build_lib_example(
+  NAME pfifo-vs-red
+  SOURCE_FILES pfifo-vs-red.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libpoint-to-point-layout}
+    ${libinternet}
+    ${libapplications}
+    ${libtraffic-control}
+)
+
+build_lib_example(
+  NAME codel-vs-pfifo-basic-test
+  SOURCE_FILES codel-vs-pfifo-basic-test.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libnetwork}
+    ${libinternet}
+    ${libapplications}
+    ${libtraffic-control}
+)
+
+build_lib_example(
+  NAME codel-vs-pfifo-asymmetric
+  SOURCE_FILES codel-vs-pfifo-asymmetric.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libnetwork}
+    ${libinternet}
+    ${libapplications}
+    ${libtraffic-control}
+)
+
+build_lib_example(
+  NAME pie-example
+  SOURCE_FILES pie-example.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libinternet}
+    ${libapplications}
+    ${libflow-monitor}
+    ${libtraffic-control}
+)
+
+build_lib_example(
+  NAME fqcodel-l4s-example
+  SOURCE_FILES fqcodel-l4s-example.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libinternet}
+    ${libinternet-apps}
+    ${libapplications}
+    ${libflow-monitor}
+    ${libtraffic-control}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/traffic-control/examples/fqcodel-l4s-example.cc ns-3.36/src/traffic-control/examples/fqcodel-l4s-example.cc
--- ns-3.35/src/traffic-control/examples/fqcodel-l4s-example.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/traffic-control/examples/fqcodel-l4s-example.cc	2022-04-30 18:23:58.166735000 -0700
@@ -24,6 +24,11 @@
  */
 
 // The 9 configurations below test BIC and DCTCP under various scenarios.
+// Scenarios are numbered 1-9.  By default, scenario number 0 (i.e., no
+// scenario) is configured, which means that the user is free to set
+// any of the parameters freely; if scenarios 1 through 9 are selected,
+// the scenario parameters are fixed.
+//
 // The configuration of the scenarios starts from basic TCP BIC without ECN
 // with the base RTT of 80ms and then in the next scenario, ECN is enabled,
 // and gradually, the complexity of the scenario increases and the last scenario
@@ -268,9 +273,11 @@
 * ---------------
 *    --n0TcpType:           First TCP type (bic, dctcp, or reno) [bic]
 *    --n1TcpType:           Second TCP type (cubic, dctcp, or reno) []
-*    --bottleneckQueueType: M3 queue type (fq or codel) [fq]
+*    --scenarioNum:         Scenario number from the scenarios avalaible in the file (1-9) [0]
+*    --bottleneckQueueType: n2 queue type (fq or codel) [fq]
 *    --baseRtt:             base RTT [80ms]
 *    --useCeThreshold:      use CE threshold [false]
+*    --useEcn:              use ECN [true]
 *    --ceThreshold:         CE threshold [1ms]
 *    --bottleneckRate       data rate of bottleneck [100Mbps]
 *    --linkrate:            data rate of edge link to bottleneck link [1Gbps]
@@ -851,9 +858,12 @@
   Simulator::Schedule (Seconds (5) + MilliSeconds (100), &ScheduleN0PacketSinkConnection);
   Simulator::Schedule (throughputSamplingInterval, &TraceN0Throughput, &n0TcpThroughputOfStream, throughputSamplingInterval);
   // Setup scheduled traces; TCP traces must be hooked after socket creation
-  Simulator::Schedule (Seconds (15) + MilliSeconds (100), &ScheduleN1TcpRttTraceConnection, &n1TcpRttOfStream);
-  Simulator::Schedule (Seconds (15) + MilliSeconds (100), &ScheduleN1TcpCwndTraceConnection, &n1TcpCwndOfStream);
-  Simulator::Schedule (Seconds (15) + MilliSeconds (100), &ScheduleN1PacketSinkConnection);
+  if (enableN1Tcp)
+    {
+      Simulator::Schedule (Seconds (15) + MilliSeconds (100), &ScheduleN1TcpRttTraceConnection, &n1TcpRttOfStream);
+      Simulator::Schedule (Seconds (15) + MilliSeconds (100), &ScheduleN1TcpCwndTraceConnection, &n1TcpCwndOfStream);
+      Simulator::Schedule (Seconds (15) + MilliSeconds (100), &ScheduleN1PacketSinkConnection);
+    }
   Simulator::Schedule (throughputSamplingInterval, &TraceN1Throughput, &n1TcpThroughputOfStream, throughputSamplingInterval);
   Simulator::Schedule (marksSamplingInterval, &TraceMarksFrequency, &marksFrequencyOfStream, marksSamplingInterval);
   Simulator::Schedule (marksSamplingInterval, &TraceDropsFrequency, &dropsFrequencyOfStream, marksSamplingInterval);
@@ -880,4 +890,4 @@
   lengthOfStream.close ();
   queueDelayN0OfStream.close ();
   queueDelayN1OfStream.close ();
-}
\ No newline at end of file
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/traffic-control/helper/traffic-control-helper.h ns-3.36/src/traffic-control/helper/traffic-control-helper.h
--- ns-3.35/src/traffic-control/helper/traffic-control-helper.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/traffic-control/helper/traffic-control-helper.h	2022-04-30 18:23:58.166735000 -0700
@@ -48,6 +48,9 @@
 
   virtual ~QueueDiscFactory () {}
 
+  // Delete default constructor to avoid misuse
+  QueueDiscFactory () = delete;
+
   /**
    * \brief Add a factory to create an internal queue
    *
@@ -87,13 +90,6 @@
   Ptr<QueueDisc> CreateQueueDisc (const std::vector<Ptr<QueueDisc> > & queueDiscs);
 
 private:
-  /**
-   * \brief Default constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  QueueDiscFactory ();
-
   /// Factory to create this queue disc
   ObjectFactory m_queueDiscFactory;
   /// Vector of factories to create internal queues
@@ -127,6 +123,7 @@
   virtual ~TrafficControlHelper () {}
 
   /**
+   * \param nTxQueues the number of Tx queue disc classes
    * \returns a new TrafficControlHelper with a default configuration
    *
    * The default configuration is an FqCoDelQueueDisc, if the device has a single
@@ -272,6 +269,12 @@
    *
    * This method removes the root queue discs (and associated filters, classes
    * and queues) installed on the given devices.
+   * Note that the traffic control layer will continue to perform flow control
+   * if the device has an aggregated NetDeviceQueueInterface. If you really
+   * want that the Traffic Control layer forwards packets down to the NetDevice
+   * even if there is no room for them in the NetDevice queue(s), then disable
+   * the flow control by using the DisableFlowControl method of the NetDevice
+   * helper.
    */
   void Uninstall (NetDeviceContainer c);
 
@@ -280,6 +283,12 @@
    *
    * This method removes the root queue disc (and associated filters, classes
    * and queues) installed on the given device.
+   * Note that the traffic control layer will continue to perform flow control
+   * if the device has an aggregated NetDeviceQueueInterface. If you really
+   * want that the Traffic Control layer forwards packets down to the NetDevice
+   * even if there is no room for them in the NetDevice queue(s), then disable
+   * the flow control by using the DisableFlowControl method of the NetDevice
+   * helper.
    */
   void Uninstall (Ptr<NetDevice> d);
 
@@ -288,6 +297,7 @@
    * Actual implementation of the SetRootQueueDisc method.
    *
    * \param factory the factory used to create the root queue disc
+   * \returns zero on success
    */
   uint16_t DoSetRootQueueDisc (ObjectFactory factory);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/traffic-control/model/cobalt-queue-disc.cc ns-3.36/src/traffic-control/model/cobalt-queue-disc.cc
--- ns-3.35/src/traffic-control/model/cobalt-queue-disc.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/traffic-control/model/cobalt-queue-disc.cc	2022-04-30 18:23:58.166735000 -0700
@@ -129,16 +129,6 @@
   return (uint32_t)(((uint64_t)A * R) >> 32);
 }
 
-double min (double x, double y)
-{
-  return (x < y) ? x : y;
-}
-
-double max (double x, double y)
-{
-  return (x > y) ? x : y;
-}
-
 /**
  * Returns the current time translated in CoDel time representation
  * \return the current time
@@ -408,7 +398,7 @@
   if (CoDelTimeAfter ((now - m_lastUpdateTimeBlue), Time2CoDel (m_target)))
     {
       NS_LOG_LOGIC ("inside IF block");
-      m_pDrop = min (m_pDrop + m_increment, (double)1.0);
+      m_pDrop = std::min (m_pDrop + m_increment, (double)1.0);
       m_lastUpdateTimeBlue = now;
     }
   m_dropping = true;
@@ -425,7 +415,7 @@
   NS_LOG_FUNCTION (this);
   if (m_pDrop && CoDelTimeAfter ((now - m_lastUpdateTimeBlue), Time2CoDel (m_target)))
     {
-      m_pDrop = max (m_pDrop - m_decrement, (double)0.0);
+      m_pDrop = std::max (m_pDrop - m_decrement, (double)0.0);
       m_lastUpdateTimeBlue = now;
     }
   m_dropping = false;
@@ -501,7 +491,7 @@
       isMarked = (m_useEcn && Mark (item, FORCED_MARK));
       drop = !isMarked;
 
-      m_count = max (m_count, m_count + 1);
+      m_count = std::max (m_count, m_count + 1);
 
       InvSqrt ();
       m_dropNext = ControlLaw (m_dropNext);
@@ -530,7 +520,7 @@
   // Enable Blue Enhancement if sojourn time is greater than blueThreshold and its been m_target time until the last time blue was updated
   if (CoDelTimeAfter (sojournTime, Time2CoDel (m_blueThreshold)) && CoDelTimeAfter ((now - m_lastUpdateTimeBlue), Time2CoDel (m_target)))
     {
-      m_pDrop = min (m_pDrop + m_increment, (double)1.0);
+      m_pDrop = std::min (m_pDrop + m_increment, (double)1.0);
       m_lastUpdateTimeBlue = now;
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/traffic-control/model/cobalt-queue-disc.h ns-3.36/src/traffic-control/model/cobalt-queue-disc.h
--- ns-3.35/src/traffic-control/model/cobalt-queue-disc.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/traffic-control/model/cobalt-queue-disc.h	2022-04-30 18:23:58.166735000 -0700
@@ -165,6 +165,9 @@
    */
   int64_t ControlLaw (int64_t t);
 
+  /**
+   * \brief Updates the inverse square root
+   */
   void InvSqrt (void);
 
   /**
@@ -210,7 +213,8 @@
 
   /**
    * Called to decide whether the current packet should be dropped based on decisions taken by Blue and Codel working parallely
-   * Returns true if the packet should be dropped, false otherwise
+   *
+   * \return true if the packet should be dropped, false otherwise
    * \param item current packet
    * \param now time in CoDel time units (microseconds)
    */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/traffic-control/model/fq-codel-queue-disc.cc ns-3.36/src/traffic-control/model/fq-codel-queue-disc.cc
--- ns-3.35/src/traffic-control/model/fq-codel-queue-disc.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/traffic-control/model/fq-codel-queue-disc.cc	2022-04-30 18:23:58.170735000 -0700
@@ -329,8 +329,7 @@
               NS_LOG_DEBUG ("Increase deficit for new flow index " << flow->GetIndex ());
               flow->IncreaseDeficit (m_quantum);
               flow->SetStatus (FqCoDelFlow::OLD_FLOW);
-              m_oldFlows.push_back (flow);
-              m_newFlows.pop_front ();
+              m_oldFlows.splice (m_oldFlows.end (), m_newFlows, m_newFlows.begin ());
             }
           else
             {
@@ -347,8 +346,7 @@
             {
               NS_LOG_DEBUG ("Increase deficit for old flow index " << flow->GetIndex ());
               flow->IncreaseDeficit (m_quantum);
-              m_oldFlows.push_back (flow);
-              m_oldFlows.pop_front ();
+              m_oldFlows.splice (m_oldFlows.end (), m_oldFlows, m_oldFlows.begin ());
             }
           else
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/traffic-control/model/pie-queue-disc.cc ns-3.36/src/traffic-control/model/pie-queue-disc.cc
--- ns-3.35/src/traffic-control/model/pie-queue-disc.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/traffic-control/model/pie-queue-disc.cc	2022-04-30 18:23:58.170735000 -0700
@@ -89,7 +89,7 @@
                    MakeTimeChecker ())
     .AddAttribute ("MaxBurstAllowance",
                    "Current max burst allowance before random drop",
-                   TimeValue (MilliSeconds (15)),
+                   TimeValue (MilliSeconds (150)),
                    MakeTimeAccessor (&PieQueueDisc::m_maxBurst),
                    MakeTimeChecker ())
     .AddAttribute ("UseDequeueRateEstimator",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/traffic-control/model/prio-queue-disc.h ns-3.36/src/traffic-control/model/prio-queue-disc.h
--- ns-3.35/src/traffic-control/model/prio-queue-disc.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/traffic-control/model/prio-queue-disc.h	2022-04-30 18:23:58.170735000 -0700
@@ -26,6 +26,7 @@
 
 namespace ns3 {
 
+/// Priority map
 typedef std::array<uint16_t, 16> Priomap;
 
 /**
@@ -106,6 +107,7 @@
  */
 std::istream &operator >> (std::istream &is, Priomap &priomap);
 
+
 ATTRIBUTE_HELPER_HEADER (Priomap);
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/traffic-control/model/queue-disc.cc ns-3.36/src/traffic-control/model/queue-disc.cc
--- ns-3.35/src/traffic-control/model/queue-disc.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/traffic-control/model/queue-disc.cc	2022-04-30 18:23:58.170735000 -0700
@@ -24,7 +24,6 @@
 #include "ns3/object-vector.h"
 #include "ns3/packet.h"
 #include "ns3/socket.h"
-#include "ns3/unused.h"
 #include "ns3/simulator.h"
 #include "queue-disc.h"
 #include "ns3/net-device-queue-interface.h"
@@ -402,9 +401,8 @@
   NS_LOG_FUNCTION (this);
 
   // Check the configuration and initialize the parameters of this queue disc
-  bool ok = CheckConfig ();
+  [[maybe_unused]] bool ok = CheckConfig ();
   NS_ASSERT_MSG (ok, "The queue disc configuration is not correct");
-  NS_UNUSED (ok); // suppress compiler warning
   InitializeParams ();
 
   // Check the configuration and initialize the parameters of the child queue discs
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/traffic-control/model/queue-disc.h ns-3.36/src/traffic-control/model/queue-disc.h
--- ns-3.35/src/traffic-control/model/queue-disc.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/traffic-control/model/queue-disc.h	2022-04-30 18:23:58.170735000 -0700
@@ -205,21 +205,21 @@
     /// Total packets dropped before enqueue
     uint32_t nTotalDroppedPacketsBeforeEnqueue;
     /// Packets dropped before enqueue, for each reason
-    std::map<std::string, uint32_t> nDroppedPacketsBeforeEnqueue;
+    std::map<std::string, uint32_t, std::less<>> nDroppedPacketsBeforeEnqueue;
     /// Total packets dropped after dequeue
     uint32_t nTotalDroppedPacketsAfterDequeue;
     /// Packets dropped after dequeue, for each reason
-    std::map<std::string, uint32_t> nDroppedPacketsAfterDequeue;
+    std::map<std::string, uint32_t, std::less<>> nDroppedPacketsAfterDequeue;
     /// Total dropped bytes
     uint64_t nTotalDroppedBytes;
     /// Total bytes dropped before enqueue
     uint64_t nTotalDroppedBytesBeforeEnqueue;
     /// Bytes dropped before enqueue, for each reason
-    std::map<std::string, uint64_t> nDroppedBytesBeforeEnqueue;
+    std::map<std::string, uint64_t, std::less<>> nDroppedBytesBeforeEnqueue;
     /// Total bytes dropped after dequeue
     uint64_t nTotalDroppedBytesAfterDequeue;
     /// Bytes dropped after dequeue, for each reason
-    std::map<std::string, uint64_t> nDroppedBytesAfterDequeue;
+    std::map<std::string, uint64_t, std::less<>> nDroppedBytesAfterDequeue;
     /// Total requeued packets
     uint32_t nTotalRequeuedPackets;
     /// Total requeued bytes
@@ -227,11 +227,11 @@
     /// Total marked packets
     uint32_t nTotalMarkedPackets;
     /// Marked packets, for each reason
-    std::map<std::string, uint32_t> nMarkedPackets;
+    std::map<std::string, uint32_t, std::less<>> nMarkedPackets;
     /// Total marked bytes
     uint32_t nTotalMarkedBytes;
     /// Marked bytes, for each reason
-    std::map<std::string, uint64_t> nMarkedBytes;
+    std::map<std::string, uint64_t, std::less<>> nMarkedBytes;
 
     /// constructor
     Stats ();
@@ -288,6 +288,10 @@
 
   virtual ~QueueDisc ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  QueueDisc (const QueueDisc &) = delete;
+  QueueDisc & operator = (const QueueDisc &) = delete;
+
   /**
    * \brief Get the number of packets stored by the queue disc
    * \return the number of packets stored by the queue disc.
@@ -565,23 +569,6 @@
 
 private:
   /**
-   * \brief Copy constructor
-   * \param o object to copy
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  QueueDisc (const QueueDisc &o);
-
-  /**
-   * \brief Assignment operator
-   * \param o object to copy
-   * \returns the copied object
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  QueueDisc &operator = (const QueueDisc &o);
-
-  /**
    * This function actually enqueues a packet into the queue disc.
    * \param item item to enqueue
    * \return True if the operation was successful; false otherwise
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/traffic-control/model/traffic-control-layer.cc ns-3.36/src/traffic-control/model/traffic-control-layer.cc
--- ns-3.35/src/traffic-control/model/traffic-control-layer.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/traffic-control/model/traffic-control-layer.cc	2022-04-30 18:23:58.170735000 -0700
@@ -44,6 +44,12 @@
                    MakeObjectMapAccessor (&TrafficControlLayer::GetNDevices,
                                           &TrafficControlLayer::GetRootQueueDiscOnDeviceByIndex),
                    MakeObjectMapChecker<QueueDisc> ())
+    .AddTraceSource ("TcDrop",
+                     "Trace source indicating a packet has been dropped by the Traffic "
+                     "Control layer because no queue disc is installed on the device, the "
+                     "device supports flow control and the device queue is stopped",
+                     MakeTraceSourceAccessor (&TrafficControlLayer::m_dropped),
+                     "ns3::Packet::TracedCallback")
   ;
   return tid;
 }
@@ -373,9 +379,9 @@
     {
       // The device has no attached queue disc, thus add the header to the packet and
       // send it directly to the device if the selected queue is not stopped
+      item->AddHeader ();
       if (!devQueueIface || !devQueueIface->GetTxQueue (txq)->IsStopped ())
         {
-          item->AddHeader ();
           // a single queue device makes no use of the priority tag
           if (!devQueueIface || devQueueIface->GetNTxQueues () == 1)
             {
@@ -384,6 +390,10 @@
             }
           device->Send (item->GetPacket (), item->GetAddress (), item->GetProtocol ());
         }
+      else
+        {
+          m_dropped (item->GetPacket ());
+        }
     }
   else
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/traffic-control/model/traffic-control-layer.h ns-3.36/src/traffic-control/model/traffic-control-layer.h
--- ns-3.35/src/traffic-control/model/traffic-control-layer.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/traffic-control/model/traffic-control-layer.h	2022-04-30 18:23:58.170735000 -0700
@@ -22,6 +22,7 @@
 #include "ns3/object.h"
 #include "ns3/address.h"
 #include "ns3/net-device.h"
+#include "ns3/traced-callback.h"
 #include "ns3/node.h"
 #include "ns3/queue-item.h"
 #include <map>
@@ -108,6 +109,10 @@
 
   virtual ~TrafficControlLayer ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  TrafficControlLayer (TrafficControlLayer const &) = delete;
+  TrafficControlLayer & operator = (TrafficControlLayer const &) = delete;
+
   /**
    * \brief Register an IN handler
    *
@@ -203,17 +208,6 @@
 
 private:
   /**
-   * \brief Copy constructor
-   * Disable default implementation to avoid misuse
-   */
-  TrafficControlLayer (TrafficControlLayer const &);
-  /**
-   * \brief Assignment operator
-   * \return this object
-   * Disable default implementation to avoid misuse
-   */
-  TrafficControlLayer& operator= (TrafficControlLayer const &);
-  /**
    * \brief Protocol handler entry.
    * This structure is used to demultiplex all the protocols.
    */
@@ -254,6 +248,13 @@
   /// Map storing the required information for each device with a queue disc installed
   std::map<Ptr<NetDevice>, NetDeviceInfo> m_netDevices;
   ProtocolHandlerList m_handlers;  //!< List of upper-layer handlers
+
+  /**
+   * The trace source fired when the Traffic Control layer drops a packet because
+   * no queue disc is installed on the device, the device supports flow control and
+   * the device queue is stopped
+   */
+  TracedCallback<Ptr<const Packet>> m_dropped;
 };
 
 } // namespace ns3
